unit UWebCamPage;

{$mode delphi}

interface

uses
  Classes, SysUtils, FileUtil, UWebPage, UHTTPServer, UHtmlClasses, USqlDatabase;

type

  { TWebCamPage }

  TWebCamPage = class(TWebPage)
    procedure DataModuleProduce(HandlerData: THTTPHandlerData);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  WebCamPage: TWebCamPage;

implementation

{$R *.lfm}

uses
  UCore, UUtils;


{ TWebCamPage }

procedure TWebCamPage.DataModuleProduce(HandlerData: THTTPHandlerData);
var
  RefreshInterval: Integer;
  WebCamImage: string;
  DbRows: TDbRows;
  I: Integer;
  CameraId: Integer;
  IdParam: string;
  LastFileDate: string;
  ImageWidth, ImageHeight: Integer;
  ImageWidthThumb, ImageHeightThumb: Integer;
begin
  with TWebSession(HandlerData) do begin
    LoadUserInfo;
    with HtmlDocument.Body, THtmlString(SubItems.AddNew(THtmlString.Create)) do begin
      Text := '';
    //for I := 0 to HandlerData.Request.Query.Count - 1 do
      //Text := Text + HandlerData.Request.Query[I] + ' ';

      //HandlerData.Request.Query.Values['W'] := 'dsd';
      //HandlerData.Request.Query.Values['H'] := 'dsd';
      if HandlerData.Request.Query.SearchKey('Id') = -1 then CameraId := -1
        else CameraId := StrToInt(HandlerData.Request.Query.Values['Id']);
      if (HandlerData.Request.Query.SearchKey('W') = -1) then begin
        ImageWidth := 640;
      end else begin
        ImageWidth := StrToInt(HandlerData.Request.Query.Values['W']);
      end;

      if CameraId >= 0 then IdParam := '&Id=' + IntToStr(CameraId)
        else IdParam := '';
      Text := Text + '<table style="width: 100%"><tr><td style="width: 20%" valign="top">' +
        '<strong>Velikost</strong><br/>' +
        '<a href="?W=160' + IdParam + '">Malá</a><br/> ' +
        '<a href="?W=320' + IdParam + '">Menší</a><br/> ' +
        '<a href="?W=640' + IdParam + '">Střední</a><br/> ' +
        '<a href="?W=1024' + IdParam + '">Větší</a><br/> ' +
        '<a href="?W=1280' + IdParam + '">Velká</a><br/><br/>';

      Text := Text + '<strong>Místní kamery</strong><br/>';
      Text := Text + '<a href="?W=' + IntToStr(ImageWidth) + '">Všechny</a><br/>';
      try
        DbRows := TDbRows.Create;
        Database.Query(DbRows, 'SELECT * FROM `Webcam` WHERE `Enabled`=1');
        for I := 0 to DbRows.Count - 1 do begin
          Text := Text + '<a href="?Id=' + DbRows[I].Values['Id'] + '&W=' + IntToStr(ImageWidth) +
          '">' + DbRows[I].Values['Name'] + '</a><br/>';
        end;
      finally
        DbRows.Free;
      end;

      Text := Text + '<br/><strong>Kamery v okolí:</strong><br />' +
        '<a href="http://www.mestovsetin.cz/vismo/dokumenty2.asp?id_org=18676&id=480245">Vsetínské kamery</a><br />' +
        '<a href="http://www.huslenky.cz/?page=kamery&I=2">Kamery v Huslenkách</a><br/>' +
        '<a href="http://kamery.hovnet.cz/">Kamery v Hovnetu</a><br/>' +
        '</td><td style="width: 80%" valign="top">';

      if CameraId = -1 then begin
        try
          DbRows := TDbRows.Create;
          Database.Query(DbRows, 'SELECT * FROM `Webcam` WHERE `Enabled`=1');
          ImageWidthThumb := 160;
          for I := 0 to DbRows.Count - 1 do begin
            ImageHeightThumb := Round(ImageWidthThumb * StrToInt(DbRows[I].Values['Height']) / StrToInt(DbRows[I].Values['Width']));
            WebCamImage := 'images/webcam/' + DbRows[I].Values['ImageName'];
            Text := Text + '<span align="center" valign="middle" style="vertical-align: middle;">' + //DbRows[I].Values['Name'] + '<br/>' +
              '<a href="?Id=' + DbRows[I].Values['Id'] + '&W=' + IntToStr(ImageWidth) + '">' +
              '<img name="theImage" src="' + NavigationLink('/' + WebCamImage) + '" width="' +
            IntToStr(ImageWidthThumb) + '" height="' + IntToStr(ImageHeightThumb) + '" alt="' +
            DbRows[I].Values['Name'] + '"/></a></span> ';
          end;
        finally
          DbRows.Free;
        end;
      end else
      try
        DbRows := TDbRows.Create;
        Database.Query(DbRows, 'SELECT * FROM `Webcam` WHERE (`Id`=' +
          IntToStr(CameraId) + ') AND (`Enabled`=1)');
        if DbRows.Count > 0 then begin

          WebCamImage := 'images/webcam/' + DbRows[0].Values['ImageName'];
          RefreshInterval := StrToInt(DbRows[0].Values['ImagePeriod']);
          CameraId := StrToInt(DbRows[0].Values['Id']);
          ImageHeight := Round(ImageWidth * StrToInt(DbRows[0].Values['Height']) / StrToInt(DbRows[0].Values['Width']));

        if FileExists(WebCamImage) then begin
        DateTimeToString(LastFileDate, 'hh:mm:ss d.m.yyyy', FileDateToDateTime(FileAge(WebCamImage)));
        Text := Text + '<script language="JavaScript">' + #13#10 +
        '  var ImageURL= "' + NavigationLink('/' + WebCamImage) + '";' + #13#10 +
        '' + #13#10 +
        '// Force an immediate image load' + #13#10 +
        'var theTimer = setTimeout("reloadImage()", 1);' + #13#10 +
        '' + #13#10 +
        'function reloadImage()' + #13#10 +
        '{' + #13#10 +
        '  theDate = new Date();' + #13#10 +
        '  var url = ImageURL;' + #13#10 +
        '  url += "?dummy=";' + #13#10 +
        '  url += theDate.getTime().toString(10);' + #13#10 +
        '  // The above dummy cgi-parameter enforce a bypass of the browser image cache.' + #13#10 +
        '  // Here we actually load the image' + #13#10 +
        '  document.theImage.src = document.theImageTemp.src;' + #13#10 +
        '  document.theImageTemp.src = url;' + #13#10 +
        '' + #13#10 +
        '  // Reload the image every defined period' + #13#10 +
        '  theTimer = setTimeout("reloadImage()", ' + IntToStr(RefreshInterval * 1000) + ');' + #13#10 +
        '}' + #13#10 +
        '</script>' + #13#10 +

        '<br /><div align="center">' + DbRows[0].Values['Name'] + '<br/>' +
        '<img name="theImageTemp" src="' + NavigationLink('/' + WebCamImage) + '" width="0" height="0" alt="Temp image"/>' +
        '<img name="theImage" src="' + NavigationLink('/' + WebCamImage) + '" width="' + IntToStr(ImageWidth) +
        '" height="' + IntToStr(ImageHeight) + '" alt="' +
        DbRows[0].Values['Name'] + '"/><br/>Aktualizace: <span id="lasttime">' +
          LastFileDate + '</span>, Perioda: ' +
          IntToStr(RefreshInterval) + ' sekund, Typ: ' + DbRows[0].Values['DeviceType'] + '<br />' +
          '<br/>' + DbRows[0].Values['Description'] + '</div>';
        end else Text := Text + '<br />Obrázek nenalezen.<br /><br />';
        end else Text := Text + '<br />Id kamery nenalezeno.<br/><br>';
      finally
        DbRows.Free;
      end;
      Text := Text + '</td></tr></table>';
    end;
    GeneratePage(Self);
  end;
end;

end.

